/* Copyright (c) 2011, S V N Vishwanathan
 * All rights reserved. 
 * 
 * The contents of this file are subject to the Mozilla Public License 
 * Version 1.1 (the "License"); you may not use this file except in 
 * compliance with the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS IS" 
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the 
 * License for the specific language governing rights and limitations 
 * under the License. 
 * 
 * Authors: S V N Vishwanathan (vishy@stat.purdue.edu)
 *          Ankan Saha (ankans@gmail.com)
 *          Xinhua Zhang (xinhua.zhang.cs@gmail.com)
 *
*/

#ifndef _ROCSCORELOSS_HPP_
#define _ROCSCORELOSS_HPP_

#include "appctx.hpp"
#include <cassert>

namespace rocscore{

  // Computation of the function value and the gradient for the smoothed
  // loss
  PetscErrorCode loss_grad(PetscScalar *fx_array, 
                           PetscScalar *labels_array, 
                           PetscScalar *grad_array, 
                           PetscInt    n, 
                           PetscScalar *loss,
                           AppCtx      *user);
  
  
  // only get the original nonsmooth objective value (no need of the gradient) 
  PetscErrorCode orig_loss(PetscScalar *fx_array, 
                           PetscScalar *labels_array, 
                           PetscInt    n, 
                           PetscScalar *loss,
                           AppCtx      *user);
  
  PetscErrorCode init(AppCtx *user);
  
  PetscErrorCode finalize(void);
}

#endif
